diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/ircd.c ircd-hybrid-fuis/src/ircd.c
--- ircd-hybrid-7.0rc9/src/ircd.c	Sun Feb 16 16:22:25 2003
+++ ircd-hybrid-fuis/src/ircd.c	Wed Mar 12 15:54:10 2003
@@ -45,7 +45,6 @@
 #include "ircdauth.h"
 #include "ircd_signal.h"
 #include "list.h"
-#include "s_gline.h"
 #include "motd.h"
 #include "ircd_handler.h"
 #include "md5.h"
@@ -117,6 +116,7 @@
 int     debuglevel = -1;        /* Server debug level */
 char*   debugmode  = "";        /*  -"-    -"-   -"-  */
 time_t  nextconnect = 1;        /* time for next try_connections call */
+int      ServicesOn  = 0;
 
 /* Set to zero because it should be initialized later using
  * initialize_server_capabs
@@ -404,10 +404,12 @@
   InitMessageFile( USER_MOTD, MPATH, &ConfigFileEntry.motd );
   InitMessageFile( OPER_MOTD, OPATH, &ConfigFileEntry.opermotd );
   InitMessageFile( USER_LINKS, LIPATH, &ConfigFileEntry.linksfile );
+  InitMessageFile( OPERS_FILE, OFPATH, &ConfigFileEntry.fopers );
 
   ReadMessageFile( &ConfigFileEntry.motd );
   ReadMessageFile( &ConfigFileEntry.opermotd );
   ReadMessageFile( &ConfigFileEntry.linksfile );
+  ReadMessageFile( &ConfigFileEntry.fopers );
 }
 
 /*
@@ -530,11 +532,11 @@
 {
   /* Check to see if the user is running us as root, which is a nono */
   
-  if(geteuid() == 0)
+/*  if(geteuid() == 0)
   {
     fprintf(stderr, "Don't run ircd as root!!!\n");
     return -1;
-  }
+  }*/
 
   /*
    * save server boot time right away, so getrusage works correctly
@@ -581,7 +583,6 @@
   ConfigFileEntry.configfile = CPATH;   /* Server configuration file */
   ConfigFileEntry.klinefile = KPATH;    /* Server kline file */
   ConfigFileEntry.dlinefile = DLPATH;   /* dline file */
-  ConfigFileEntry.glinefile = GPATH;    /* gline log file */
 
   myargv = argv;
   umask(077);                /* better safe than sorry --SRB */
@@ -731,7 +732,12 @@
 #ifdef VCHANS
   eventAddIsh("clear_channels", clear_channels, NULL, 1800);
 #endif
-  eventAddIsh("cleanup_glines", cleanup_glines, NULL, CLEANUP_GLINES_TIME);
+
+  eventAddIsh("check_warn_drone", check_warn_drone, NULL, CHECK_DRONE_TIME);
+ 
+  eventAddIsh("check_drone_queue", check_drone_queue, NULL, ConfigFileEntry.drone_rate_period);
+
+  eventAddIsh("purge_repeats", purge_repeats, NULL, ConfigFileEntry.repeat_grace);
 
   eventAddIsh("cleanup_tklines", cleanup_tklines, NULL, CLEANUP_TKLINES_TIME);
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/ircd_lexer.l ircd-hybrid-fuis/src/ircd_lexer.l
--- ircd-hybrid-7.0rc9/src/ircd_lexer.l	Wed Oct 30 12:44:56 2002
+++ ircd-hybrid-fuis/src/ircd_lexer.l	Fri Mar  7 13:21:33 2003
@@ -170,20 +170,24 @@
 fallback_to_ip6_int { return FALLBACK_IP6_INT; }
 flatten_links	{ return FLATTEN_LINKS; }
 fname_foperlog  { return FNAME_FOPERLOG; }
+netid              { return NETID; }
+services_host  { return SERVICES_HOST; }
+services_qline { return SERVICES_QLINE; }
+network_server_site { return SERVER_SITE; }
+equivalent      { return EQUIVALENT; }
+nicks           { return NICKS; }
 fname_operlog   { return FNAME_OPERLOG; }
 fname_userlog   { return FNAME_USERLOG; }
 gecos		{ return GECOS; }
 general		{ return GENERAL; }
-gline		{ return GLINE; }
-gline_exempt    { return GLINE_EXEMPT; }
-gline_log       { return GLINE_LOG; }
-gline_time      { return GLINE_TIME; }
 global_kill	{ return GLOBAL_KILL; }
 have_ident	{ return HAVE_IDENT; }
 havent_read_conf { return HAVENT_READ_CONF; }
 hidden		{ return HIDDEN; }
 hide_servers	{ return HIDE_SERVERS; }
 host		{ return HOST; }
+maskhost    { return MASKHOST; }
+webchat    { return WEBCHAT; }
 hub		{ return HUB; }
 hub_mask	{ return HUB_MASK; }
 idletime        { return IDLETIME; }
@@ -209,6 +213,7 @@
 masked		{ return TMASKED; }
 max_buffer	{ return T_MAX_BUFFER; }
 max_clients     { return T_MAX_CLIENTS; }
+have_operwall     { return OPER_OPERWALL; }
 max_number	{ return MAX_NUMBER; }
 maximum_links   { return MAXIMUM_LINKS; }
 message_locale	{ return MESSAGE_LOCALE; }
@@ -252,6 +257,7 @@
 shared          { return T_SHARED; }
 short_motd      { return SHORT_MOTD; }
 silent          { return SILENT; }
+skip_on_fail    { return SKIP_ON_FAIL; }
 spoof		{ return SPOOF; }
 spoof_notice	{ return SPOOF_NOTICE; }
 true_no_oper_flood { return TRUE_NO_OPER_FLOOD; }
@@ -261,10 +267,13 @@
 use_except	{ return USE_EXCEPT; }
 use_halfops     { return USE_HALFOPS; }
 use_help        { return USE_HELP; }
+silence_default        { return SILENCE_DEFAULT; }
+no_colors_quit_msg     { return NO_COLORS; }
 use_invex	{ return USE_INVEX; }
 use_knock	{ return USE_KNOCK; }
 use_vchans      { return USE_VCHANS; }
 throttle_time { return THROTTLE_TIME; }
+how_old { return HOW_OLD; }
 user		{ return USER;} 
 vchans_oper_only { return VCHANS_OPER_ONLY; }
 vhost	{ return VHOST; }
@@ -282,11 +291,24 @@
 ts_max_delta            { return TS_MAX_DELTA; }
 ts_warn_delta           { return TS_WARN_DELTA; }
 links_delay           { return LINKS_DELAY; }
+grace_time              { return GRACE_TIME; }
 kline_with_connection_closed { return KLINE_WITH_CONNECTION_CLOSED; }
 kline_with_reason       { return KLINE_WITH_REASON; }
 warn_no_nline           { return WARN_NO_NLINE; }
 non_redundant_klines    { return NON_REDUNDANT_KLINES; }
-
+userpar         { return USERPAR; }
+param           { return PARAM; }
+dccforb         { return DCCFORB; }
+fileext           { return FILEEXT; }
+quitcheck         { return QUITCHECK; }
+adv_text           { return ADV_TEXT; }
+repeat_grace        { return REPEAT_GRACE; }
+drone_rate_max      { return DRONE_RATE_MAX; }
+drone_rate_period   { return DRONE_RATE_PERIOD; }
+drone_kline         { return DRONE_KLINE; }
+drone_batch         { return DRONE_BATCH; }
+drone_kline_time    { return DRONE_KLINE_TIME; }
+drone_reason        { return DREASON; }
 stats_o_oper_only       { return STATS_O_OPER_ONLY; }
 stats_k_oper_only	{ return STATS_K_OPER_ONLY; }
 stats_i_oper_only	{ return STATS_I_OPER_ONLY; }
@@ -297,7 +319,6 @@
 knock_delay_channel	{ return KNOCK_DELAY_CHANNEL; }
 iauth_server            { return IAUTH_SERVER; }
 iauth_port		{ return IAUTH_PORT; }
-glines                  { return GLINES; }
 max_bans                { return MAX_BANS; }
 modules                 { return MODULES; }
 module                  { return MODULE; }
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/ircd_parser.y ircd-hybrid-fuis/src/ircd_parser.y
--- ircd-hybrid-7.0rc9/src/ircd_parser.y	Tue Nov 12 08:45:42 2002
+++ ircd-hybrid-fuis/src/ircd_parser.y	Fri Mar  7 13:22:10 2003
@@ -100,6 +100,25 @@
 %token  AUTH
 %token  AUTOCONN
 %token  BYTES KBYTES MBYTES GBYTES TBYTES
+%token  USERPAR
+%token  PARAM
+
+%token  DCCFORB
+%token  FILEEXT
+%token  QUITCHECK
+%token  ADV_TEXT
+
+%token  DRONE_RATE_MAX
+%token  DRONE_RATE_PERIOD
+%token  DRONE_KLINE
+%token  DRONE_BATCH
+%token  DRONE_KLINE_TIME
+%token  DREASON
+%token  REPEAT_GRACE
+
+%token  EQUIVALENT
+%token  NICKS
+
 %token  CALLER_ID_WAIT
 %token  CAN_FLOOD
 %token  CHANNEL
@@ -135,19 +154,22 @@
 %token  FNAME_FOPERLOG
 %token  FNAME_OPERLOG
 %token  FNAME_USERLOG
+%token  NETID
+%token  SERVICES_HOST
+%token  OPERSS_FILE
+%token  SERVICES_QLINE
+%token  SERVER_SITE
 %token  GECOS
 %token  GENERAL
-%token  GLINE
-%token  GLINES
-%token  GLINE_EXEMPT
-%token  GLINE_LOG
-%token  GLINE_TIME
 %token  GLOBAL_KILL
 %token  HAVE_IDENT
 %token	HAVENT_READ_CONF
 %token  HIDDEN
 %token  HIDE_SERVERS
 %token  HOST
+%token  MASKHOST
+%token  WEBCHAT
+%token  SKIP_ON_FAIL
 %token  HUB
 %token  HUB_MASK
 %token  IAUTH_PORT
@@ -260,6 +282,7 @@
 %token  T_MAX_CLIENTS
 %token  T_NCHANGE
 %token  T_OPERWALL
+%token  OPER_OPERWALL
 %token  T_REJ
 %token  T_SERVNOTICE
 %token  T_SKILL
@@ -267,6 +290,7 @@
 %token  T_UNAUTH
 %token  T_WALLOP
 %token  THROTTLE_TIME
+%token  HOW_OLD
 %token  TRUE_NO_OPER_FLOOD
 %token  UNKLINE
 %token  USER
@@ -275,9 +299,12 @@
 %token  USE_EXCEPT
 %token  USE_HALFOPS
 %token  USE_HELP
+%token  SILENCE_DEFAULT
+%token  NO_COLORS
 %token  USE_INVEX
 %token  USE_KNOCK
 %token  USE_VCHANS
+%token  GRACE_TIME
 %token  VCHANS_OPER_ONLY
 %token  VHOST
 %token  VHOST6
@@ -313,7 +340,11 @@
 		| exempt_entry
 		| general_entry
                 | gecos_entry
+                | userpar_entry
+				| dccforb_entry
+				| quitcheck_entry
                 | modules_entry
+				| equivalent_entry
                 | error ';'
                 | error '}'
         ;
@@ -621,7 +652,7 @@
                         logging_item ;
 
 logging_item:           logging_path | logging_oper_log |
-                        logging_gline_log | logging_log_level |
+                        logging_log_level |
 			error;
 
 logging_path:           T_LOGPATH '=' QSTRING ';' 
@@ -632,10 +663,6 @@
                         {
                         };
 
-logging_gline_log:	GLINE_LOG '=' QSTRING ';'
-                        {
-                        };
-
 logging_log_level:     LOG_LEVEL '=' T_L_CRIT ';'
   { set_log_level(L_CRIT); }
                        |
@@ -740,8 +767,8 @@
                 oper_item;
 
 oper_item:      oper_name  | oper_user | oper_password |
-                oper_class | oper_global_kill | oper_remote |
-                oper_kline | oper_unkline | oper_gline | oper_nick_changes |
+                oper_class | oper_global_kill | oper_remote | oper_operwall |
+		oper_kline | oper_unkline | oper_nick_changes |
                 oper_die | oper_rehash | oper_admin | oper_rsa_public_key_file | error;
 
 oper_name:      NAME '=' QSTRING ';'
@@ -856,6 +883,10 @@
 oper_remote: REMOTE '=' TYES ';' { yy_achead->port |= CONF_OPER_REMOTE;}
              |
              REMOTE '=' TNO ';' { yy_achead->port &= ~CONF_OPER_REMOTE; } ;
+	     
+oper_operwall: OPER_OPERWALL '=' TYES ';' { yy_achead->port |= CONF_OPER_OPERWALL;}
+             |
+             OPER_OPERWALL '=' TNO ';' { yy_achead->port &= ~CONF_OPER_OPERWALL; } ;
 
 oper_kline: KLINE '=' TYES ';' { yy_achead->port |= CONF_OPER_K;}
             |
@@ -865,10 +896,6 @@
               |
               UNKLINE '=' TNO ';' { yy_achead->port &= ~CONF_OPER_UNKLINE; } ;
 
-oper_gline: GLINE '=' TYES ';' { yy_achead->port |= CONF_OPER_GLINE;}
-            |
-            GLINE '=' TNO ';' { yy_achead->port &= ~CONF_OPER_GLINE; };
-
 oper_nick_changes: NICK_CHANGES '=' TYES ';' { yy_achead->port |= CONF_OPER_N;}
                    |
                    NICK_CHANGES '=' TNO ';' { yy_achead->port &= ~CONF_OPER_N;};
@@ -951,6 +978,81 @@
     class_sendq_var = $3;
   };
 
+/***************************************************************************
+ *  section equivalent, defines equivalent nicks          -demond
+ ***************************************************************************/
+
+equivalent_entry:   EQUIVALENT
+  {
+  }
+  '{' equivalent_items '}' ';'
+  {
+  };
+
+equivalent_items:   equivalent_items equivalent_item |
+                    equivalent_item
+;
+equivalent_item:    equivalent_nicks | error
+;
+equivalent_nicks:   NICKS '=' QSTRING ';'
+  {
+    add_equiv_nicks(yylval.string);
+  };
+
+/***************************************************************************
+ *  section userpar, defines USER constant parameters
+ *  by various clients, mostly Java applets                    -demond
+ ***************************************************************************/
+
+ userpar_entry:      USERPAR
+ { }
+ '{' userpar_items '}' ';'
+  {  };
+
+ userpar_items:      userpar_items userpar_item | userpar_item;
+ userpar_item:       userpar_param | error;
+
+ userpar_param:      PARAM '=' QSTRING ';'
+ {
+   add_userpar_param(yylval.string);
+ };
+
+/***************************************************************************
+ *  section dccforb, defines file types that wont be accepted (by DCC) if the
+ *  user has mode +D
+ ***************************************************************************/
+
+ dccforb_entry:      DCCFORB
+ { }
+ '{' dccforb_items '}' ';'
+  {  };
+
+ dccforb_items:      dccforb_items dccforb_item | dccforb_item;
+ dccforb_item:       dccforb_fileext | error;
+
+ dccforb_fileext:      FILEEXT '=' QSTRING ';'
+ {
+   add_dccforb_fileext(yylval.string);
+ };
+
+/***************************************************************************
+ *  section quitcheck, defines which words in the quit message will be
+ *  considered as advertisment and it will be blocked (the quit messages
+ *  will be blanked to Client Quit).
+ ***************************************************************************/
+
+ quitcheck_entry:      QUITCHECK
+ { }
+ '{' quitcheck_items '}' ';'
+  {  };
+
+ quitcheck_items:      quitcheck_items quitcheck_item | quitcheck_item;
+ quitcheck_item:       quitcheck_adv_text | error;
+
+ quitcheck_adv_text:      ADV_TEXT '=' QSTRING ';'
+ {
+   add_adv_text(yylval.string);
+ };
 
 /***************************************************************************
  *  section listen
@@ -1074,10 +1176,10 @@
 
 auth_item:      auth_user | auth_passwd | auth_class |
                 auth_kline_exempt | auth_have_ident | auth_is_restricted |
-                auth_exceed_limit | auth_no_tilde | auth_gline_exempt |
-                auth_spoof | auth_spoof_notice |
+                auth_exceed_limit | auth_no_tilde |
+                auth_spoof | auth_spoof_notice | auth_maskhost | auth_webchat |
                 auth_redir_serv | auth_redir_port | auth_can_flood |
-                error;
+				auth_skipfail | error;
 
 auth_user:   USER '=' QSTRING ';'
   {
@@ -1204,17 +1306,6 @@
     yy_achead->flags &= ~CONF_FLAGS_NO_TILDE;
   };
 
-auth_gline_exempt:  GLINE_EXEMPT '=' TYES ';' 
-  {
-    yy_achead->flags |= CONF_FLAGS_EXEMPTGLINE;
-  }
-                    |
-                    GLINE_EXEMPT '=' TNO ';'
-  {
-    yy_achead->flags &= ~CONF_FLAGS_EXEMPTGLINE;
-  };
-
-
 auth_redir_serv:    REDIRSERV '=' QSTRING ';'
   {
     yy_achead->flags |= CONF_FLAGS_REDIR;
@@ -1234,6 +1325,32 @@
     DupString(yy_achead->className, yylval.string);
   };
 
+auth_maskhost: MASKHOST '=' TYES ';'
+  {
+     yy_achead->flags |= CONF_FLAGS_MASKHOST;
+ }
+ |            MASKHOST '=' TNO ';'
+ {
+  yy_achead->flags &= CONF_FLAGS_MASKHOST;
+};
+
+auth_webchat: WEBCHAT '=' TYES ';'
+  {
+     yy_achead->flags |= CONF_FLAGS_WEBCHAT;
+ }
+ |            WEBCHAT '=' TNO ';'
+ {
+  yy_achead->flags &= CONF_FLAGS_WEBCHAT;
+};
+
+auth_skipfail: SKIP_ON_FAIL '=' TYES ';'
+ {
+	  yy_achead->flags |= CONF_FLAGS_SKIPFAIL;
+ }
+ |            SKIP_ON_FAIL '=' TNO ';'
+ {
+  yy_achead->flags &= CONF_FLAGS_SKIPFAIL;
+};
 
 /***************************************************************************
  *  section resv
@@ -1948,7 +2065,10 @@
                     general_max_nick_changes | general_max_accept |
                     general_anti_spam_exit_message_time |
                     general_ts_warn_delta | general_ts_max_delta |
-                    general_kline_with_reason |
+                    general_kline_with_reason | general_grace_time |
+                    general_drate_max | general_drate_period |
+                    general_drone_kline | general_drone_batch |
+                    general_drone_ktime | general_drone_reason |
                     general_kline_with_connection_closed |
                     general_warn_no_nline |
                     general_non_redundant_klines | general_dots_in_ident |
@@ -1959,21 +2079,23 @@
                     general_true_no_oper_flood |
                     general_iauth_server |
                     general_iauth_port |
-                    general_glines | general_gline_time |
                     general_idletime |
                     general_maximum_links |
                     general_message_locale | general_client_exit |
                     general_fname_userlog | general_fname_operlog |
                     general_fname_foperlog | general_oper_only_umodes |
-                    general_max_targets |
+                    general_max_targets | general_services_host |
+					general_services_qline | general_network_server_site |
                     general_use_egd | general_egdpool_path |
-                    general_oper_umodes |
+                    general_oper_umodes | general_repeat_grace |
                     general_caller_id_wait | general_default_floodcount |
-                    general_min_nonwildcard |
+                    general_min_nonwildcard | general_netid |
                     general_servlink_path | general_use_help |
+					general_silence_default | general_no_colors_quit_msg |
                     general_default_cipher_preference |
                     general_compression_level | general_client_flood |
                     general_throttle_time | general_havent_read_conf |
+					general_how_old |
                     general_dot_in_ip6_addr | general_ping_cookie |
                     general_fallback_to_ip6_int | 
                     error;
@@ -2038,6 +2160,46 @@
     exit(0);
   }
 };
+general_repeat_grace:  REPEAT_GRACE '=' timespec ';'
+  {
+      ConfigFileEntry.repeat_grace = $3;
+  } ;
+
+general_drate_max:     DRONE_RATE_MAX '=' NUMBER ';'
+  {
+    ConfigFileEntry.drone_rate_max = $3;
+  } ;
+
+general_drate_period:  DRONE_RATE_PERIOD '=' timespec ';'
+  {
+    ConfigFileEntry.drone_rate_period = $3;
+  } ;
+
+general_drone_ktime:   DRONE_KLINE_TIME '=' timespec ';'
+  {
+    ConfigFileEntry.drone_kline_time = $3;
+  } ;
+
+general_drone_kline:   DRONE_KLINE '=' TYES ';'
+  {
+    ConfigFileEntry.drone_kline = 1;
+  }
+    |
+    DRONE_KLINE '=' TNO ';'
+  {
+    ConfigFileEntry.drone_kline = 0;
+  } ;
+
+general_drone_batch:   DRONE_BATCH '=' TYES ';'
+  {
+    ConfigFileEntry.drone_batch = 1;
+  }
+    |
+    DRONE_BATCH '=' TNO ';'
+  {
+    ConfigFileEntry.drone_batch = 0;
+  } ;
+
 general_kline_with_reason: KLINE_WITH_REASON '=' TYES ';'
   {
     ConfigFileEntry.kline_with_reason = 1;
@@ -2209,21 +2371,40 @@
 	      MAXPATHLEN);
 };
 
+general_netid: NETID '=' QSTRING ';'
+{
+  strlcpy(ConfigFileEntry.netid, yylval.string, MAXNETID);
+};
+
+general_services_host: SERVICES_HOST '=' QSTRING ';'
+{
+  MyFree(ConfigFileEntry.services_host);
+  DupString(ConfigFileEntry.services_host, yylval.string);
+};
+
+general_services_qline: SERVICES_QLINE '=' QSTRING ';'
+{
+  MyFree(ConfigFileEntry.services_qline);
+  DupString(ConfigFileEntry.services_qline, yylval.string);
+};
+
+general_network_server_site: SERVER_SITE '=' QSTRING ';'
+{
+  MyFree(ConfigFileEntry.network_server_site);
+  DupString(ConfigFileEntry.network_server_site, yylval.string);
+};
+
+
 general_fname_operlog: FNAME_OPERLOG '=' QSTRING ';'
 {
   strlcpy(ConfigFileEntry.fname_operlog, yylval.string,
 	      MAXPATHLEN);
 };
 
-general_glines: GLINES '=' TYES ';'
-  {
-    ConfigFileEntry.glines = 1;
-  } 
-    |
-    GLINES '=' TNO ';'
-  {
-    ConfigFileEntry.glines = 0;
-  } ;
+general_drone_reason: DREASON '=' QSTRING ';'
+{
+  strlcpy(ConfigFileEntry.drone_reason, yylval.string, MAXDREASON);
+};
 
 general_message_locale: MESSAGE_LOCALE '=' QSTRING ';'
   {
@@ -2234,11 +2415,6 @@
     putenv(langenv);
   } ;
 
-general_gline_time: GLINE_TIME '=' timespec ';'
-  {
-    ConfigFileEntry.gline_time = $3;
-  } ;
-
 general_idletime: IDLETIME '=' timespec ';'
   {
     ConfigFileEntry.idletime = $3;
@@ -2354,11 +2530,36 @@
     ConfigFileEntry.use_help = 0;
   } ;
 
+general_silence_default: SILENCE_DEFAULT '=' TYES ';'
+  {
+    ConfigFileEntry.silence_default = 1;
+  }
+    |
+    SILENCE_DEFAULT '=' TNO ';'
+  {
+    ConfigFileEntry.silence_default = 0;
+  } ;
+
+general_no_colors_quit_msg: NO_COLORS '=' TYES ';'
+  {
+    ConfigFileEntry.no_colors_quit_msg = 1;
+  }
+    |
+    NO_COLORS '=' TNO ';'
+  {
+    ConfigFileEntry.no_colors_quit_msg = 0;
+  } ;
+
 general_throttle_time: THROTTLE_TIME '=' timespec ';'
 {
  ConfigFileEntry.throttle_time = yylval.number;
 } ;
 
+general_how_old: HOW_OLD '=' timespec ';'
+{
+ ConfigFileEntry.how_old = yylval.number;
+} ;
+
 general_fallback_to_ip6_int: FALLBACK_IP6_INT '=' TYES ';'
 {
 #ifdef IPV6
@@ -2820,6 +3021,11 @@
 
   };
 
+general_grace_time:    GRACE_TIME '=' timespec ';'
+  {
+      ConfigFileEntry.grace_time = $3;
+  } ;
+
 serverhide_hidden: HIDDEN '=' TYES ';'
   {
     ConfigServerHide.hidden = 1;
@@ -2839,6 +3045,3 @@
   {
     ConfigServerHide.disable_hidden = 0;
   };
-  
-  
-  
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/ircdauth.c ircd-hybrid-fuis/src/ircdauth.c
--- ircd-hybrid-7.0rc9/src/ircdauth.c	Tue Feb  4 00:30:50 2003
+++ ircd-hybrid-fuis/src/ircdauth.c	Wed Mar 12 15:54:10 2003
@@ -330,8 +330,6 @@
 	 */
 	buffer[length] = '\0';
 
-	fprintf(stderr, "%s", buffer);
-
 	/*
 	 * buffer could possibly contain several lines of info,
 	 * especially if this is the inital connect burst, so go
@@ -700,7 +698,7 @@
 
 #if 0
   sendto_serv_butone(client,
-		     "NICK %s %d %lu %s %s %s %s :%s",
+		     "NICK %s %d %lu %s %s %s %s %s :%s",
 		     client->name,
 		     client->hopcount + 1,
 		     client->tsinfo,
@@ -708,30 +706,31 @@
 		     client->username,
 		     client->host,
 		     client->user->server,
+			 client->host,
 		     client->info);
 #endif
 
   if (!ServerInfo.hub && uplink && IsCapable(uplink,CAP_LL))
   {
-    sendto_one(uplink, "NICK %s %d %lu %s %s %s %s :%s",
+    sendto_one(uplink, "NICK %s %d %lu %s %s %s %s %s :%s",
 		client->name,
 		client->hopcount+1,
 		(unsigned long) client->tsinfo,
 		ubuf,
 		client->username, client->host,
-		client->user->server, client->info);
+		client->user->server, client->host, client->info);
   }
   else
   {
     /* send to all servers, except LL servers */
     sendto_server(NULL, NULL, NULL, NOCAPS, CAP_LL,
-                  NOFLAGS, "NICK %s %d %lu %s %s %s %s :%s",
+                  NOFLAGS, "NICK %s %d %lu %s %s %s %s %s :%s",
                   client->name,
                   client->hopcount+1,
                   (unsigned long) client->tsinfo,
                   ubuf,
                   client->username, client->host,
-                  client->user->server, client->info);
+                  client->user->server, client->host, client->info);
   }
   if (ubuf[1])
   {
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/list.c ircd-hybrid-fuis/src/list.c
--- ircd-hybrid-7.0rc9/src/list.c	Tue Jan 28 16:04:06 2003
+++ ircd-hybrid-fuis/src/list.c	Wed Mar 12 16:09:42 2003
@@ -38,7 +38,7 @@
 #include "send.h"
 #include "memory.h"
 #include "balloc.h"
-
+#include "s_conf.h"
 
 /* XXX assummed 32 bit ints */
 int links_count=0;
@@ -134,32 +134,31 @@
 free_user(struct User* user, struct Client* client_p)
 {
   if (--user->refcnt <= 0)
-  {
-    if (user->away)
-      MyFree((char *)user->away);
-    /*
-     * sanity check
-     */
-    if (user->joined || user->refcnt < 0 ||
-	user->invited.head || user->channel.head)
     {
-      sendto_realops_flags(FLAGS_ALL, L_ALL,
-			   "* %#lx user (%s!%s@%s) %#lx %#lx %#lx %d %d *",
-			   (unsigned long)client_p, client_p ? client_p->name : "<noname>",
-			   client_p->username, client_p->host, (unsigned long)user,
-			   (unsigned long)user->invited.head,
-			   (unsigned long)user->channel.head, user->joined,
-			   user->refcnt);
-      assert(!user->joined);
-      assert(!user->refcnt);
-      assert(!user->invited.head);
-      assert(!user->channel.head);
+      if (user->away)
+        MyFree((char *)user->away);
+      /*
+       * sanity check
+       */
+      if (user->joined || user->refcnt < 0 ||
+          user->invited.head || user->channel.head)
+      {
+        sendto_realops_flags(FLAGS_ALL, L_ALL,
+			     "* %#lx user (%s!%s@%s) %#lx %#lx %#lx %d %d *",
+			     (unsigned long)client_p, client_p ? client_p->name : "<noname>",
+			     client_p->username, client_p->host, (unsigned long)user,
+			     (unsigned long)user->invited.head,
+			     (unsigned long)user->channel.head, user->joined,
+			     user->refcnt);
+        assert(!user->joined);
+        assert(!user->refcnt);
+        assert(!user->invited.head);
+        assert(!user->channel.head);
+      }
+      BlockHeapFree(user_heap, user);
+      --user_count;
+      assert(user_count >= 0);
     }
-
-    BlockHeapFree(user_heap, user);
-    --user_count;
-    assert(user_count >= 0);
-  }
 }
 
 
@@ -240,7 +239,3 @@
   *count = links_count;
   *links_memory_used = links_count * sizeof(dlink_node);
 }
-
-
-
-
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/match.c ircd-hybrid-fuis/src/match.c
--- ircd-hybrid-7.0rc9/src/match.c	Wed Aug 28 13:00:14 2002
+++ ircd-hybrid-fuis/src/match.c	Sun Feb  9 08:21:21 2003
@@ -403,7 +403,7 @@
   '_',
   '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
   'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
-  't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
+  't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^',
   0x7f,
   0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
   0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
@@ -434,7 +434,7 @@
   ':', ';', '<', '=', '>', '?',
   '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
   'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
-  'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^',
+  'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~',
   0x5f,
   '`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
   'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/messages.tab ircd-hybrid-fuis/src/messages.tab
--- ircd-hybrid-7.0rc9/src/messages.tab	Thu Jan 16 18:10:56 2003
+++ ircd-hybrid-fuis/src/messages.tab	Sun Feb 16 11:17:57 2003
@@ -248,7 +248,7 @@
 /* 225 RPL_STATSDLINE*/         ":%s 225 %s %c %s :%s",
 /* 226 RPL_STATSALINE*/         ":%s 226 %s %s",
 /* 227 */       NULL,
-/* 228 */       NULL,
+/* 228 RPL_EQUIVALENTS*/   ":%s 228 %s Equiv %s/%s",
 /* 229 */       NULL,
 /* 230 */       NULL,
 /* 231 */       NULL,
@@ -291,7 +291,7 @@
 /* 264 */       NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
-/* 267 */       NULL,
+/* 267 RPL_IDENTUSERS, */       ":%s 267 %s :Current identified users: %d  Max: %d",
 /* 268 */       NULL,
 /* 269 */       NULL,
 /* 270 */       NULL,
@@ -337,29 +337,29 @@
 /* 310 */       NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
 /* 312 RPL_WHOISSERVER, */      ":%s 312 %s %s %s :%s",
-/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is an IRC Operator",
+/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :%s",
 /* 314 RPL_WHOWASUSER, */       ":%s 314 %s %s %s %s * :%s",
 /* 315 RPL_ENDOFWHO, */         ":%s 315 %s %s :End of /WHO list.",
 /* 316 RPL_WHOISCHANOP, */      NULL,
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :%s",
-/* 320 */      NULL,
+/* 320 RPL_SERVICESCHANS, */	":%s 320 %s %s :Is a services nickname (channel list hidden)",
 /* 321 RPL_LISTSTART, */        ":%s 321 %s Channel :Users  Name",
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
 /* 324 RPL_CHANNELMODEIS, */    ":%s 324 %s %s %s %s",
-/* 325 */       NULL,
-/* 326 */       NULL,
-/* 327 */       NULL,
-/* 328 */       NULL,
+/* 325 RPL_NS_ID */              ":%s 325 %s %s :is idented to NS", 
+/* 326 RPL_OS_ID */              ":%s 326 %s %s :is Services Administrator",
+/* 327 RPL_NK_ID */              ":%s 327 %s %s :is a NetKeeper", 
+/* 328 RPL_SILENCE */            ":%s 328 %s %s :is in Silence mode!",
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
-/* 330 */       NULL,
+/* 330 RPL_AVFH, */				 ":%s 330 %s %s :is available for help",
 /* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
 /* 333 RPL_TOPICWHOTIME, */     ":%s 333 %s %s %s %lu",
-/* 334 */       NULL,
-/* 335 */       NULL,
+/* 334 RPL_WHOISREALHOST, */    ":%s 334 %s %s :logged on %s from %s",
+/* 335 RPL_NOLIST, */			":%s 335 %s %s :channel list hidden.",
 /* 336 */       NULL,
 /* 337 */       NULL,
 /* 338 RPL_WHOISACTUALLY */	":%s 338 %s :%s is actually %s@%s [%s]",
@@ -394,7 +394,7 @@
 /* 367 RPL_BANLIST, */          ":%s 367 %s %s %s %s %lu",
 /* 368 RPL_ENDOFBANLIST, */     ":%s 368 %s %s :End of Channel Ban List",
 /* 369 RPL_ENDOFWHOWAS, */      ":%s 369 %s %s :End of WHOWAS",
-/* 370 */       NULL,
+/* 370 RPL_LINKSUSERS, */       ":%s 370 %s :Please look %s for a full list of the IRC Servers",
 /* 371 RPL_INFO, */             ":%s 371 %s :%s",
 /* 372 RPL_MOTD, */             ":%s 372 %s :- %s",
 /* 373 RPL_INFOSTART, */        ":%s 373 %s :Server INFO",
@@ -477,7 +477,7 @@
 /* 449 */       NULL,
 /* 450 */       NULL,
 /* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You have not registered",
-/* 452 */       NULL,
+/* 452 ERR_NOREPEATING, */      ":%s 452 %s %s :No repeating allowed (+z)",
 /* 453 */       NULL,
 /* 454 */       NULL,
 /* 455 */       NULL,
@@ -513,15 +513,15 @@
 /* 484 ERR_RESTRICTED, */       ":%s 484 %s :You are restricted",
 /* 485 ERR_BANNEDNICK, */
        ":%s 485 %s :Can't change nick when banned or on a moderated channel (%s)",
-/* 486 */       NULL,
-/* 487 */       NULL,
-/* 488 */       NULL,
-/* 489 */       NULL,
-/* 490 */       NULL,
+/* 486 ERR_SERVICESNICKHOP, */  ":%s 486 %s %s :Can't op/deop Services nick!",
+/* 487 ERR_SERVICESNICKKICK, */ ":%s 487 %s %s :Can't kick Services nick!",
+/* 488 ERR_NOKICK, */ ":%s 488 %s %s :Can't kick this user he's overprotected by Services!",
+/* 489 ERR_NOCOLOR, */ ":%s 489 %s %s :Colors are forbidden on this channel!",
+/* 490 ERR_JOINF, */   ":%s 490 %s %s :Can't join the channel, because your nick is either not regged or too young!",
 /* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Only few of mere mortals may try to enter the twilight zone",
-/* 492 */       NULL,
-/* 493 */       NULL,
-/* 494 */       NULL,
+/* 492 ERR_NOCTCP, */		":%s 492 %s %s :CTCP messages from non +v/+o/+h are forbidden!",
+/* 493 ERR_NOTALK, */		":%s 493 %s %s :You can't talk on this channel, while your nickname is not regged ot regged too recently!",
+/* 494 ERR_NOSPAM, */		":%s 494 %s %s :You can't send this to the channel, while it contains a spam phrase, if you think it's not contact the admin (/ADMIN)",
 /* 495 */       NULL,
 /* 496 */       NULL,
 /* 497 */       NULL,
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/modules.c ircd-hybrid-fuis/src/modules.c
--- ircd-hybrid-7.0rc9/src/modules.c	Tue Jan 21 09:26:51 2003
+++ ircd-hybrid-fuis/src/modules.c	Sun Mar  9 19:07:45 2003
@@ -57,18 +57,7 @@
 
 static char *core_module_table[] =
 {
-  "m_die.s",
-  "m_kick.s",
-  "m_kill.s",
-  "m_message.s",
-  "m_mode.s",
-  "m_nick.s",
-  "m_part.s",
-  "m_quit.s",
-  "m_server.s",
-  "m_sjoin.s",
-  "m_squit.s",
-  NULL
+    NULL
 };
 
 #define MODS_INCREMENT 10
@@ -571,7 +560,6 @@
 	mod_add_cmd(&dmem_msgtab);
 	mod_add_cmd(&drop_msgtab);
 	mod_add_cmd(&eob_msgtab);
-	mod_add_cmd(&gline_msgtab);
 	mod_add_cmd(&help_msgtab);
 	mod_add_cmd(&info_msgtab);
 	mod_add_cmd(&invite_msgtab);
